﻿Public Class Form1

    Dim USB_PORT As New System.IO.Ports.SerialPort   'declares a handle for COM port called USB_I2C
    Dim SerBuf(10) As Byte                          'a global accessable array for data to be buffered for the COMX port
    Dim relay_states As Byte


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Show all available COM ports.
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComboBoxPortSelect.Items.Add(sp)         'adds COMX to listbox called "comportselect"
        Next

    End Sub

    Private Sub ComboBoxPortSelect_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxPortSelect.SelectedIndexChanged
        If (USB_PORT.IsOpen) Then     'if program has previously opened a COM port, start by closing it
            USB_PORT.Close()
        End If
        Try
            USB_PORT = My.Computer.Ports.OpenSerialPort(ComboBoxPortSelect.Text, 19200, 0, 8, 2) ' attempt to open a new COM port
        Catch                                       'catch open failures
            Return
        End Try
        USB_PORT.ReadTimeout = 100                 'we will only arrive here on successfull open

        SerBuf(0) = 90                      ' get module id and version command
        Try
            USB_PORT.Write(SerBuf, 0, 1)        ' send the command to the USB-RLY16 module
            USB_PORT.Read(SerBuf, 0, 2)         ' retrieve module id followed by version
        Catch ex As Exception                   ' timeout for response close comport
            USB_PORT.Close()
            MessageBox.Show("ERROR NO RLY16 FOUND")
        End Try
        If ((SerBuf(0) <> 9) and USB_PORT.IsOpen) Then
            USB_PORT.Close()
            MessageBox.Show("ERROR NO RLY16 FOUND")
        End If
    End Sub
    Private Sub READUSBRLY16(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        If (USB_PORT.IsOpen) Then               '   checks that a port has actually been opened to talk down
            SerBuf(0) = 90                      ' get software version Command 
            USB_PORT.Write(SerBuf, 0, 1)        ' send the command to the USB-RLY16 module
            While (USB_PORT.BytesToRead < 2)
            End While
            USB_PORT.Read(SerBuf, 0, 2)         ' retrieve module id followed by version
            TextBoxVer.Text = SerBuf(1)         ' ignore serbuf(0) (module id) and print the version in the textbox
            SerBuf(0) = 93                      ' get DC voltage command
            USB_PORT.Write(SerBuf, 0, 1)        ' send the command to the USB-RLY16 module
            USB_PORT.Read(SerBuf, 0, 1)         ' retrieve DC voltage to serbuf(0)
            TextBoxDcIn.Text = SerBuf(0) / 10
            SerBuf(0) = 91                      ' get relay states command
            USB_PORT.Write(SerBuf, 0, 1)        ' send the command to the USB-RLY16 module
            USB_PORT.Read(SerBuf, 0, 1)         ' retrieve relay states to serbuf(0)
            relay_states = SerBuf(0)
            If (relay_states And 1) Then        ' looks at bits within returned byte and sets button colours accordingly
                ButtonRelay1.BackColor = Color.Red
            Else : ButtonRelay1.BackColor = Color.White
            End If
            If (relay_states And 2) Then
                ButtonRelay2.BackColor = Color.Red
            Else : ButtonRelay2.BackColor = Color.White
            End If
            If (relay_states And 4) Then
                ButtonRelay3.BackColor = Color.Red
            Else : ButtonRelay3.BackColor = Color.White
            End If
            If (relay_states And 8) Then
                ButtonRelay4.BackColor = Color.Red
            Else : ButtonRelay4.BackColor = Color.White
            End If
            If (relay_states And 16) Then
                ButtonRelay5.BackColor = Color.Red
            Else : ButtonRelay5.BackColor = Color.White
            End If
            If (relay_states And 32) Then
                ButtonRelay6.BackColor = Color.Red
            Else : ButtonRelay6.BackColor = Color.White
            End If
            If (relay_states And 64) Then
                ButtonRelay7.BackColor = Color.Red
            Else : ButtonRelay7.BackColor = Color.White
            End If
            If (relay_states And 128) Then
                ButtonRelay8.BackColor = Color.Red
            Else : ButtonRelay8.BackColor = Color.White
            End If
        End If
    End Sub

    Private Sub ButtonRelay1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRelay1.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            If (relay_states And 1) Then        ' if relay is on
                SerBuf(0) = 111                 ' turn relay 1 off relay
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            Else
                SerBuf(0) = 101                 ' turn relay 1 on command
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            End If
        End If
    End Sub

    Private Sub ButtonRelay2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRelay2.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            If (relay_states And 2) Then        ' if relay is on
                SerBuf(0) = 112                 ' turn relay 2 off relay
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            Else
                SerBuf(0) = 102                 ' turn relay 2 on command
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            End If
        End If
    End Sub

    Private Sub ButtonRelay3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRelay3.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            If (relay_states And 4) Then        ' if relay is on
                SerBuf(0) = 113                 ' turn relay 3 off relay 
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            Else
                SerBuf(0) = 103                 ' turn relay 3 on command
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            End If
        End If
    End Sub

    Private Sub ButtonRelay4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRelay4.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            If (relay_states And 8) Then        ' if relay is on
                SerBuf(0) = 114                 ' turn relay 4 off relay
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            Else
                SerBuf(0) = 104                 ' turn relay 4 on command
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            End If
        End If
    End Sub

    Private Sub ButtonRelay5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRelay5.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            If (relay_states And 16) Then       ' if relay is on
                SerBuf(0) = 115                 ' turn relay 5 off relay
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            Else
                SerBuf(0) = 105                 ' turn relay 5 on command
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            End If
        End If
    End Sub

    Private Sub ButtonRelay6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRelay6.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            If (relay_states And 32) Then       ' if relay is on
                SerBuf(0) = 116                 ' turn relay 6 off relay
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            Else
                SerBuf(0) = 106                 ' turn relay 6 on command
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            End If
        End If
    End Sub

    Private Sub ButtonRelay7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRelay7.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            If (relay_states And 64) Then       ' if relay is on
                SerBuf(0) = 117                 ' turn relay 7 off relay
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            Else
                SerBuf(0) = 107                 ' turn relay 7 on command
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            End If
        End If
    End Sub

    Private Sub ButtonRelay8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRelay8.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            If (relay_states And 128) Then      ' if relay is on
                SerBuf(0) = 118                 ' turn relay 8 off relay 
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            Else
                SerBuf(0) = 108                 ' turn relay 8 on command
                USB_PORT.Write(SerBuf, 0, 1)    ' send the command to the USB-RLY16 module
            End If
        End If
    End Sub

    Private Sub ButtonAllOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAllOn.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            SerBuf(0) = 100                     ' turn all relays on ommand 
            USB_PORT.Write(SerBuf, 0, 1)        ' send the command to the USB-RLY16 module
        End If
    End Sub

    Private Sub ButtonAllOff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAllOff.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            SerBuf(0) = 110                     ' turn all relays off command 
            USB_PORT.Write(SerBuf, 0, 1)        ' send the command to the USB-RLY16 module
        End If
    End Sub

    Private Sub Button01010101_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button01010101.Click
        If (USB_PORT.IsOpen) Then               '   checks that a port has actually been opened to talk down
            SerBuf(0) = 92                      ' set all relays command 
            SerBuf(1) = 85                      ' 01010101 as decimal
            USB_PORT.Write(SerBuf, 0, 2)        ' send the command to the USB-RLY16 module
        End If
    End Sub

    Private Sub Button10101010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10101010.Click
        If (USB_PORT.IsOpen) Then               ' checks that a port has actually been opened to talk down
            SerBuf(0) = 92                      ' set all relays command 
            SerBuf(1) = 170                     ' 10101010 as decimal
            USB_PORT.Write(SerBuf, 0, 2)        ' send the command to the USB-RLY16 module
        End If
    End Sub
End Class
